--Colors
vsa.err_color="255000000" --for any errors, color red, error, use wrn_color if it's not that serious
vsa.rsp_color="255165000" --for any responses, color orange, shows when someone uses a command
vsa.wrn_color="255255000" --for any warnings, color yellow, caution messages
vsa.con_color="255069000" --for any confirmations such as banishment, color orange-red, confirmation--try to keep this at msg2
vsa.suc_color="000255000" --for any successful responses, color green, almost always a msg2, this isn't rp, green text isn't common
--Messages
vsa.sv_err=vsa.err_color.."There was a server-sided problem, please contact server administrators about this." --this is when a command fails executing, should never happen in-game, if it does show up--you failed :)
--Preset commands
vsa.toggle_commands={	"Bot Count",
					"Bot Join Team",
					"Bot Skill",
					"Bot Weapons",
					"Speed Hack Protection",
					"Auto Game Mode",
					"Auto Team Balance",
					"Buy Time",
					"Bomb Timer",
					"Curtail Explosions",
					"Damage Factor",
					"Death Drop",
					"Dispenser Health",
					"Dispenser Money",
					"Respawn Money",
					"Drop Grenades",
					"Flood Protection",
					"Freeze Time",
					"Grenade Rebuy",
					"Hostage Penalty",
					"Idle Penalty",
					"Idle Kick",
					"Idle Time",
					"Infinite Ammo",
					"Kevlar Protection",
					"Kick Percent",
					"Kill Buildings Money",
					"Leave Buildings",
					"Kill Info",
					"Kill Team Buildings",
					"Lag Compensation",
					"Log Rcon Usage",
					"Lua Map",
					"Map Goal Score",
					"Map Vote Ratio",
					"Max Clients IP",
					"Max Rcon Fails",
					"Nat Hole Punching",
					"Ping Limit",
					"Post Spawn Time",
					"Radar",
					"Random Spawn",
					"Team Kill Penalty",
					"Teleport Reload",
					"Temporary Ban Time",
					"Time Limit",
					"Team Kill Punish",
					"Trace",
					"Turret Damage",
					"Vulnerable Hostages",
					"Weapon Fade Out Time",
					"Win Limit",
					"Zombie Armor Protection",
					"Zombie Kill Equip",
					"Zombie Kill Score",
					"Zombie Recover",
					"Zombie Speed Mod",
					"Fog Of War",
					"Friendly Fire",
					"Game Mode",
					"Lan",
					"Map Transfer",
					"Max Players",
					"Spectator Mode",
					"Spray Transfer",
					"USGN Only",
					"Transfer Speed",
					"Respawn Delay",
					"Round Limit",
					"Round Time",
					"Start Money",	
					"Server Name"
				}
vsa.toggle_actions={		"bot_count",
					"bot_jointeam",
					"bot_skill",
					"bot_weapons",
					"mp_antispeeder",
					"mp_autogamemode",
					"mp_autoteambalance",
					"mp_buytime",
					"mp_c4timer",
					"mp_curtailedexplosions",
					"mp_damagefactor",
					"mp_deathdrop",
					"mp_dispenser_health",
					"mp_dispenser_money",
					"mp_dmspawnmoney",
					"mp_dropgrenades",
					"mp_floodprot",
					"mp_freezetime",
					"mp_grenaderebuy",
					"mp_hostagepenalty",
					"mp_idleaction",
					"mp_idlekick",
					"mp_idletime",
					"mp_infammo",
					"mp_kevlar",
					"mp_kickpercent",
					"mp_killbuildingmoney",
					"mp_killbuildings",
					"mp_killinfo",
					"mp_killteambuildings",
					"mp_lagcompensation",
					"mp_localrconoutput",
					"mp_luamap",
					"mp_mapgoalscore",
					"mp_mapvoteratio",
					"mp_maxclientsip",
					"mp_maxrconfails",
					"mp_natholepunching",
					"mp_pinglimit",
					"mp_postspawn",
					"mp_radar",
					"mp_randomspawn",
					"mp_teamkillpenalty",
					"mp_teleportreload",
					"mp_tempbantime",
					"mp_timelimit",
					"mp_tkpunish",
					"mp_trace",
					"mp_turretdamage",
					"mp_vulnerablehostages",
					"mp_weaponfadeout",
					"mp_winlimit",
					"mp_zombiedmg",
					"mp_zombiekillequip",
					"mp_zombiekillscore",
					"mp_zombierecover",
					"mp_zombiespeedmod",
					"sv_fow",
					"sv_friendlyfire",
					"sv_gamemode",
					"sv_lan",
					"sv_maptransfer",
					"sv_maxplayers",
					"sv_specmode",
					"sv_spraytransfer",
					"sv_usgnonly",
					"transfer_speed",
					"mp_respawndelay",
					"mp_roundlimit",
					"mp_roundtime",
					"mp_startmoney",
					"sv_name"
				}
vsa.toggle_paranames={	{"Zero","One","Two","Three","Four","Five","Six","Seven","Eight","Nine","Ten","Eleven","Twelve","Thirteen","Fourteen","Fifteen","Sixteen","Seventeen","Eighteen","Nineteen","Twenty","Twenty-One","Twenty-Two","Twenty-Three","Twenty-Four","Twenty-Five","Twenty-Six","Twenty-Seven","Twenty-Eight","Twenty-Nine","Thirty","Thirty-One","Thirty-Two"},
					{"Both","T","CT"},
					{"Very Low","Low","Normal","Advanced","Professional"},
					{"All Weapons","Melee Only","Shotguns Only","Smgs Only","Sniper Rifles Only","Mgs Only"},
					{"On","Off"},
					{"On","Off"},
					{"On","Off"},
					{"No Buy Time","10 Secs","30 Secs","1 Min","2 Mins","3 Mins","Forever"},
					{"35 Secs","40 Secs","50 Secs","1 Min","2 Mins","3 Mins","255 Secs"},
					{"On","Off"},
					{"No Damage","Normal Damage","Half Damage","Double Damage","Triple Damage","1 Shot Kill"},
					{"Everything","Prim+Sec+Defuse+NV","Prim+Sec+Defuse","Prim+Sec","Nothing"},
					{"No Health","1 HP","5 HP","10 HP","15 HP","20 HP","100 HP"},
					{"No Money","$1","$10","$100","$1000","$1500","$16000"},
					{"No Money","$10","$500","$1000","$1500","$2000","$16000"},
					{"Allowed","Not Allowed"},
					{"On","Off"},
					{"No Freeze Time","1 Sec","3 Secs","5 Secs","10 Secs","20 Secs","30 Secs"},
					{"Allowed","Not Allowed"},
					{"Instant Kick","1 Hostage","2 Hostages","5 Hostages","8 Hostages","15 Hostages","No Kick"},
					{"Kick","Make Spectator","Slap","Kill","Show Message"},
					{"Kick","Don't Kick"},
					{"10 Secs","15 Secs","20 Secs","30 Secs","1 Min","2 Mins","3 Mins"},
					{"Enabled","Disbaled"},
					{"No Protection","10%","20%","30%","40%","50%","100%"},
					{"Disabled","10%","20%","40%","50%","60%","100%"},
					{"Enabled","Disabled"},
					{"Kill All","Leave Walls","Kill Disp.+Turret+Supply","Leave All"},
					{"Show","Hide"},
					{"Unkillable","Killable","Killable+Penalty"},
					{"100 Ping","200 Ping","300 Ping","400 Ping","500 Ping","600 Ping","1000 Ping"},
					{"On","Off"},
					{"Enabled","Disabled"},
					{"Enabled","Disabled"},
					{"Disabled","10%","30%","50%","60%","90%","100%"},
					{"1 IP","2 IPS","4 IPS","5 IPS","10 IPS","20 IPS","32 IPS"},
					{"Unlimited","1 Time","2 Times","3 Times","5 Times","10 Times","15 Times"},
					{"Enabled","Disabled"},
					{"No Limit","100 Ping","200 Ping","300 Ping","500 Ping","600 Ping","1000 Ping"},
					{"Disabled","10 Seconds","20 Seconds","30 Seconds","1 Min","2 Mins","3 Mins"},
					{"Show","Hide"},
					{"Enabled","Disabled"},
					{"Disabled","1 Team Kill","3 Team Kills","5 Team Kills","10 Team Kills","15 Team Kills","20 Team Kills"},
					{"Instant","1 Sec","5 Sec","10 Sec","15 Sec","20 Sec","25 Sec"},
					{"1 Min","30 Mins","1 Hour","5 Hours","10 Hours","15 Hours","1 Day"},
					{"Infinite","1 Min","5 Mins","10 Mins","30 Mins","1 Hour","2 Hours"},
					{"Enabled","Disabled"},
					{"Disabled","Low","Med-Low","Medium","Med-High","High"},
					{"No Damage","1 HP","5 HP","10 HP","15 HP","20 HP","25 HP"},
					{"Vulnerable","Immune"},
					{"Never","10 Secs","15 Secs","30 Secs","40 Secs","50 Secs","1 Min"},
					{"Disabled","1 Score","2 Scores","5 Scores","10 Scores","20 Scores","30 Scores"},
					{"100%","90%","70%","50%","40%","20%","0%"},
					{"Nothing","Molotov","Gut Bomb","HE Grenade"},
					{"1 Score","2 Score","3 Score","5 Score","7 Score","8 Score","10 Score"},
					{"Disabled","1 HP","3 HP","5 HP","20 HP","35 HP","50 HP"},
					{"-10 Speed","0 Speed","10 Speed","15 Speed","20 Speed","25 Speed","30 Speed"},
					{"Enabled","Disabled"},
					{"Enabled","Disabled"},
					{"Standard","Deathmatch","Team Deathmatch","Construction","Zombies!"},
					{"Enabled","Disabled"},
					{"Enabled","Disabled"},
					{"One","Two","Three","Four","Five","Six","Seven","Eight","Nine","Ten","Eleven","Twelve","Thirteen","Fourteen","Fifteen","Sixteen","Seventeen","Eighteen","Nineteen","Twenty","Twenty-One","Twenty-Two","Twenty-Three","Twenty-Four","Twenty-Five","Twenty-Six","Twenty-Seven","Twenty-Eight","Twenty-Nine","Thirty","Thirty-One","Thirty-Two"},
					{"Everything","Own Team Only","Nothing"},
					{"Enabled","Disabled"},
					{"Enabled","Disabled"},
					{"5 KB","10 KB","25 KB","30 KB","35 KB","40 KB","100 KB"},
					{"Instant","1 Sec","5 Secs","10 Secs","15 Secs","20 Secs","30 Secs"},
					{"Disabled","1 Round","2 Rounds","5 Rounds","10 Rounds","15 Rounds","20 Rounds"},
					{"1 Min","2 Mins","3 Mins","5 Mins","10 Mins","13 Mins","15 Mins"},
					{"$0","$100","$800","$1000","$2000","$3000","$16000"},
					{"Server","Con Name","Death Name"}
				}
vsa.toggle_parameters={	{"0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32"},
					{"0","1","2"},
					{"0","1","2","3","4"},
					{"0","1","2","3","4","5","6","7"},
					{"1","0"},
					{"1","0"},
					{"1","0"},
					{"0.000000000","0.100000000","0.500000000","1.000000000","2.000000000","3.000000000","1000000.00"},
					{"35","40","50","60","120","180","255"},
					{"1","0"},
					{"0.000000000","1.00000000","0.500000000","2.00000000","3.00000000","1000.00000"},
					{"0","1","2","3","4"},
					{"0","1","5","10","15","20","100"},
					{"0","1","10","100","1000","1500","16000"},
					{"0","10","500","1000","1500","2000","16000"},
					{"1","0"},
					{"1","0"},
					{"0","1","3","5","10","20","30"},
					{"1","0"},
					{"0","1","2","5","8","15","1000000"},
					{"0","1","2","3","4"},
					{"1","0"},
					{"10","15","20","30","60","120","180"},
					{"1","0"},
					{"0.000000000","0.100000001","0.200000003","0.300000012","0.400000006","0.500000000","1.00000000"},
					{"0.000000000","0.100000001","0.200000003","0.400000006","0.500000000","0.660000026","1.00000000"},
					{"1","0"},
					{"0","1","2","3"},
					{"1","0"},
					{"0","1","2"},
					{"1","2","3","4","5","6","10"},
					{"1","0"},
					{"1","0"},
					{"1","0"},
					{"0.000000000","0.100000001","0.300000012","0.500000000","0.600000024","0.899999976","1.00000000"},
					{"1","2","4","5","10","20","32"},
					{"0","1","2","3","5","10","15"},
					{"1","0"},
					{"0","100","200","300","500","600","1000"},
					{"0","10","20","30","60","120","180"},
					{"1","0"},
					{"1","0"},
					{"0","1","3","5","10","15","20"},
					{"0","1","5","10","15","20","25"},
					{"1","30","60","300","600","900","1440"},
					{"0","1","5","10","30","60","120"},
					{"1","0"},
					{"0","1","2","3","4","5"},
					{"0","1","5","10","15","20","25"},
					{"1","0"},
					{"0","10","15","30","40","50","60"},
					{"0","1","2","5","10","20","30"},
					{"0.000000000","0.100000001","0.300000012","0.500000000","0.600000024","0.800000012","1.00000000"},
					{"0","73","86","51"},
					{"1","2","3","5","7","8","10"},
					{"0","1","3","5","20","35","50"},
					{"-10","0","10","15","20","25","30"},
					{"1","0"},
					{"1","0"},
					{"0","1","2","3","4"},
					{"1","0"},
					{"1","0"},
					{"1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32"},
					{"0","1","2"},
					{"1","0"},
					{"1","0"},
					{"5","10","25","30","35","40","100"},
					{"0","1","5","10","15","20","30"},
					{"0","1","2","5","10","15","20"},
					{"1","2","3","5","10","13","15"},
					{"0","100","800","1000","2000","3000","16000"},
					{"Server","Construction","DeathMatch"}
				}
--Preset menus
for key,togglecmd in ipairs(vsa.toggle_commands) do
	menus[togglecmd]=function()
		tmp=game(vsa.toggle_actions[key])
		tmp2={}
		tmp3={}
		for key2,value in ipairs(vsa.toggle_parameters[key]) do
			if tmp==value then
				table.insert(tmp2,"("..vsa.toggle_paranames[key][key2]..")|Current Setting")
			else
				table.insert(tmp2,vsa.toggle_paranames[key][key2])
			end
		end
		for key2,value in ipairs(vsa.toggle_parameters[key]) do
			table.insert(tmp3,function(id)
				if game(vsa.toggle_actions[key])==value then
					return vsa.err_color..vsa.toggle_commands[key].." was already "..vsa.toggle_paranames[key][key2]
				else
					parse(vsa.toggle_actions[key].." "..value)
					if vsa.toggle_parameters[key][1]~=nil and vsa.toggle_parameters[key][1]=="1" and vsa.toggle_parameters[key][2]~=nil and vsa.toggle_parameters[key][2]=="0" then
						if vsa.toggle_parameters[key][key2]=="0" then
							tmp4="disabled"
						else
							tmp4="enabled"
						end
						msg(string.char(169)..vsa.rsp_color..player(id,"name").." "..tmp4.." "..string.lower(vsa.toggle_commands[key])..".")
						return
					end
					msg(string.char(169)..vsa.rsp_color..player(id,"name").." changed "..string.lower(vsa.toggle_commands[key]).." to "..string.lower(vsa.toggle_paranames[key][key2])..".")
					return
				end
			end)
		end
		return {tmp2,tmp3}
	end
end

menus["Server Settings"]=vsa.toggle_commands

--Commands that are not preset need to be written with lua, these get pretty long since all checks are written twice (once for menu disable and once for error message)
menus["Show USID"]=function(id)
	if player(id,"usgn")==0 then
		return vsa.err_color.."You are not signed in a USGN account."
	else
		return vsa.rsp_color.."Your USID is "..player(id,"usgn").."."
	end
end

menus["Ban IP"]=function(id2)
local tmp={}
local tmp2={}
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"ip")==player(id2,"ip") then
			tmp3="("..player(id,"name")..")|YOURSELF - "..player(id,"ip")
		elseif player(id,"bot") then
			tmp3="("..player(id,"name")..")|BOT"
		elseif player(id,"ip")=="0.0.0.0" then
			tmp3="("..player(id,"name")..")|HOST"
		else
			tmp3=player(id,"name").."|"..player(id,"ip")
		end
		table.insert(tmp,tmp3)
		table.insert(tmp2,function(id2,text,name,ip)
					if player(id2,"ip")==player(id,"ip") then
						return vsa.err_color.."You may not ban your own IP from the server."
					elseif player(id,"ip")=="0.0.0.0" then
						return vsa.err_color.."You may not ban the host's IP from the server."
					else
					msg2(id2,string.char(169)..vsa.con_color.."Are you sure you want to ban "..name.."'s IP from the server?@C")
					tmp4={"Yes|Ban - "..ip,"No|Exit"}
					tmp5={function(id3)
							if player(id,"exists")==false or ip~=player(id,"ip") then
								msg(string.char(169)..vsa.rsp_color..player(id3,"name").." banned "..name..".")
								msg2(id3,string.char(169)..vsa.rsp_color.."Name: "..name)
								msg2(id3,string.char(169)..vsa.rsp_color.."IP: "..ip)
								parse("banip "..ip)
								return vsa.wrn_color..name.." has left the game, however their IP was still banned from the server."
							else
								msg(string.char(169)..vsa.rsp_color..player(id3,"name").." banned "..player(id,"name")..".")
								msg2(id3,string.char(169)..vsa.rsp_color.."Name: "..player(id,"name"))
								msg2(id3,string.char(169)..vsa.rsp_color.."IP: "..player(id,"ip"))
								parse("banip "..id)
								return vsa.suc_color..name.." was banned from the server."
							end
						end,
						function()
						end}
						return {tmp4,tmp5}
					end
				end)
		table.insert(tmp4,{player(id,"name"),player(id,"ip")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Ban Name"]=function(id2)
local tmp={}
local tmp2={}
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if id==id2 then
			tmp3="("..player(id,"name")..")|YOURSELF - "..player(id,"ip")
		elseif player(id,"name")==player(id2,"name") and id~=id2 then
			tmp3="("..player(id,"name")..")|Same Name"
		elseif player(id,"bot") then
			tmp3="("..player(id,"name")..")|BOT"
		elseif player(id,"ip")=="0.0.0.0" then
			tmp3="("..player(id,"name")..")|HOST"
		else
			tmp3=player(id,"name").."|"..player(id,"ip")
		end
		table.insert(tmp,tmp3)
		table.insert(tmp2,function(id2,text,name,ip)
					if player(id2,"ip")==player(id,"ip") then
						return vsa.err_color.."You may not ban your own name from the server."
					elseif player(id,"ip")=="0.0.0.0" then
						return vsa.err_color.."You may not ban the host's name from the server."
					else
					msg2(id2,string.char(169)..vsa.con_color.."Are you sure you want to ban "..name.."'s name?@C")
					tmp5={"Yes|Ban - "..name,"No|Exit"}
					tmp6={function(id3)
							if player(id,"exists")==false or ip~=player(id,"ip") then
								msg(string.char(169)..vsa.rsp_color..player(id3,"name").." banned "..name.."'s name.")
								msg2(id3,string.char(169)..vsa.rsp_color.."Name: "..name)
								parse("banname "..name)
								return vsa.wrn_color..name.." has left the game, however their name was still banned from the server."
							else
								msg(string.char(169)..vsa.rsp_color..player(id3,"name").." banned "..player(id,"name")..".")
								msg2(id3,string.char(169)..vsa.rsp_color.."Name: "..player(id,"name"))
								parse("banip "..player(id,"name"))
								return vsa.suc_color..name.." was banned from the server."
							end
						end,
						function()
						end}
						return {tmp5,tmp6}
					end
				end)
		table.insert(tmp4,{player(id,"name"),player(id,"ip")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Ban USGN"]=function(id2)
local tmp={}
local tmp2={}
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if id==id2 then
			tmp3="("..player(id,"name")..")|YOURSELF - "..player(id,"usgn")
		elseif player(id,"name")==player(id2,"usgn") and id~=id2 then
			tmp3="("..player(id,"name")..")|Same USGN"..")"
		elseif player(id,"bot") then
			tmp3="("..player(id,"name")..")|BOT"
		elseif player(id,"ip")=="0.0.0.0" then
			tmp3="("..player(id,"name")..")|HOST"
		elseif player(id,"usgn")==0 then
			tmp3="("..player(id,"name")..")|No USGN"
		else
			tmp3=player(id,"name").."|"..player(id,"ip")
		end
		table.insert(tmp,tmp3)
		table.insert(tmp2,function(id2,text,name,usgn)
					if id2==id then
						return vsa.err_color.."You may not ban your own USID from the server."
					elseif player(id,"usgn")==0 then
						return vsa.err_color..name.." is not signed into a USGN account."
					elseif player(id2,"usgn")==player(id,"usgn")  then
						return vsa.err_color.."You may not ban your own USID from the server."
					elseif player(id,"ip")=="0.0.0.0" then
						return vsa.err_color.."You may not ban the host's USID from the server."
					else
					msg2(id2,string.char(169)..vsa.con_color.."Are you sure you want to ban "..name.."'s USGN?@C")
					tmp5={"Yes|Ban - "..name,"No|Exit"}
					tmp6={function(id3)
							if player(id,"exists")==false or ip~=player(id,"ip") then
								msg(string.char(169)..vsa.rsp_color..player(id3,"name").." banned "..name.."'s USID.")
								msg2(id3,string.char(169)..vsa.rsp_color.."Name: "..name)
								parse("banusgn "..usgn)
								return vsa.wrn_color..name.." has left the game, however their USID was still banned from the server."
							else
								msg(string.char(169)..vsa.rsp_color..player(id3,"name").." banned "..player(id,"name").."'s USID.")
								msg2(id3,string.char(169)..vsa.rsp_color.."Name: "..player(id,"name"))
								parse("banusgn "..player(id,"usgn"))
								return vsa.suc_color..name.." was banned from the server."
							end
						end,
						function()
						end}
						return {tmp5,tmp6}
					end
				end)
		table.insert(tmp4,{player(id,"name"),player(id,"ip")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Add Bot"]=function()
	tmp2=0
	tmp3=0
	for _,id in ipairs(player(0,"table")) do
		if player(id,"bot") then
			if player(id,"team")==1 then
				tmp2=tmp2+1
			elseif player(id,"team")==2 then
				tmp3=tmp3+1
			end
		end
	end
	if game("mp_autoteambalance")=="1" then
		if math.abs(#player(0,"team1")-#player(0,"team2"))>=1 then
			if #player(0,"team1")>#player(0,"team2") then
				tmp={"(Terrorist)|Too Many - "..tmp2,"Counter-Terrorist|"..tmp3,"Any Team","Fill Server"}
			else
				tmp={"Terrorist|"..tmp2,"(Counter-Terrorist)|Too Many - "..tmp3,"Any Team","Fill Server"}
			end
		else
			tmp={"Terrorist|"..tmp2,"Counter-Terrorist|"..tmp3,"Any Team","Fill Server"}
		end
	else
		tmp={"Terrorist|"..tmp2,"Counter-Terrorist|"..tmp3,"Any Team","Fill Server"}
	end
	if #player(0,"table")==tonumber(game("sv_maxplayers")) then
		tmp={"(Terrorist)|Server Full","(Counter-Terrorist)|Server Full","(Any Team)|Server Full","(Fill Server)|Server Full"}
	end
	tmp4={function(id2)
			if #player(0,"table")==tonumber(game("sv_maxplayers")) then
				return vsa.err_color.."The server is full, a bot cannot be added."
			end
			if #player(0,"team1")>#player(0,"team2") and game("mp_autoteambalance")=="1" then
				return vsa.err_color.."There are too many counter-terrorists to add a terrorist bot."
			else
				parse("bot_add_t")
				msg(string.char(169)..vsa.rsp_color..player(id2,"name").." added a terrorist bot.")
				return vsa.suc_color.."A terrorist bot was added."
			end
		end,
		function(id2)
			if #player(0,"table")==tonumber(game("sv_maxplayers")) then
				return vsa.err_color.."The server is full, a bot cannot be added."
			end
			if #player(0,"team1")<#player(0,"team2") and game("mp_autoteambalance")=="1" then
				return vsa.err_color.."There are too many terrorists to add a counter-terrorist bot."
			else
				parse("bot_add_ct")
				msg(string.char(169)..vsa.rsp_color..player(id2,"name").." added a counter-terrorist bot.")
				return vsa.suc_color.."A counter-terrorist bot was added."
			end
		end,
		function(id2)
			if #player(0,"table")==tonumber(game("sv_maxplayers")) then
				return vsa.err_color.."The server is full, a bot cannot be added."
			end
			local tmp5=#player(0,"team1")
			parse("bot_add")
			if #player(0,"team1")>tmp5 then
				msg(string.char(169)..vsa.rsp_color..player(id2,"name").." added a terrorist bot.")
				return vsa.suc_color.."A terrorist bot was added."
			else
				msg(string.char(169)..vsa.rsp_color..player(id2,"name").." added a counter-terrorist bot.")
				return vsa.suc_color.."A counter-terrorist bot was added."
			end
		end,
		function(id2)
			if #player(0,"table")==tonumber(game("sv_maxplayers")) then
				return vsa.err_color.."The server is full, a bot cannot be added."
			end
			tmp2=tonumber(game("sv_maxplayers"))-#player(0,"table")
			tmp3=#player(0,"team1")
			tmp4=#player(0,"team2")
			for tmp=1,tmp2 do
				parse("bot_add")
			end
			tmp5="s"
			msg(string.char(169)..vsa.rsp_color..player(id2,"name").." filled the server with bots.")
			if #player(0,"team1")-tmp3==1 then
				tmp5=""
			end
			tmp6="s"
			if #player(0,"team2")-tmp4==1 then
				tmp6=""
			end
			msg2(id2,string.char(169)..vsa.rsp_color..#player(0,"team1")-tmp3.." terrorist bot"..tmp5.." were added to the server.")
			msg2(id2,string.char(169)..vsa.rsp_color..#player(0,"team2")-tmp4.." counter-terrorist bot"..tmp6.." were added to the server.")
			return vsa.suc_color..tmp2.." bots in total were added to the server."
		end}
	return {tmp,tmp4}
end

menus["Kill All Bots"]=function(id2)
	for _,id in ipairs(player(0,"tableliving")) do
		if player(id,"bot") then
			parse("bot_kill")
			msg(string.char(169)..vsa.rsp_color..player(id2,"name").." killed all bots.")
			return vsa.suc_color.."All bots were killed."
		end
	end
	return vsa.err_color.."There are no bots to kill."
end

menus["Remove A Bot"]=function()
	tmp2=0
	tmp3=0
	for _,id in ipairs(player(0,"table")) do
		if player(id,"bot") then
			if player(id,"team")==1 then
				tmp2=tmp2+1
			elseif player(id,"team")==2 then
				tmp3=tmp3+1
			end
		end
	end
	if tmp2==0 and tmp3~=0 then
		tmp={"(Terrorist)|"..tmp2,"Counter-Terrorist|"..tmp3,"Any Team|"..tmp3,"All|"..tmp3}
	elseif tmp3==0 and tmp2~=0 then
		tmp={"Terrorist|"..tmp2,"(Counter-Terrorist)|None","Any Team|"..tmp2,"All|"..tmp2}
	elseif tmp2==0 and tmp3==0 then
		tmp={"(Terrorist)|None","(Counter-Terrorist)|None","(Any Team)|None","(All)|None"}
	else
		tmp={"Terrorist|"..tmp2,"Counter-Terrorist|"..tmp3,"Any Team|"..tmp2+tmp3,"All|"..tmp2+tmp3}
	end
	tmp4={function(id2)
			tmp2=0
			tmp3=0
			for _,id in ipairs(player(0,"table")) do
				if player(id,"bot") then
					if player(id,"team")==1 then
						tmp2=tmp2+1
					elseif player(id,"team")==2 then
						tmp3=tmp3+1
					end
				end
			end
			if tmp2==0 and tmp3==0 then
				return vsa.err_color.."There are no bots to remove"
			elseif tmp2==0 then
				return vsa.err_color.."There are no terrorist bots to remove"
			end
			parse("bot_remove_t")
			msg(string.char(169)..vsa.rsp_color..player(id2,"name").." removed a terrorist bot.")
			return vsa.suc_color.."A terrorist bot was removed."
		end,
		function(id2)
			tmp2=0
			tmp3=0
			for _,id in ipairs(player(0,"table")) do
				if player(id,"bot") then
					if player(id,"team")==1 then
						tmp2=tmp2+1
					elseif player(id,"team")==2 then
						tmp3=tmp3+1
					end
				end
			end
			if tmp2==0 and tmp3==0 then
				return vsa.err_color.."There are no bots to remove"
			elseif tmp3==0 then
				return vsa.err_color.."There are no counter-terrorist bots to remove"
			end
			parse("bot_remove_ct")
			msg(string.char(169)..vsa.rsp_color..player(id2,"name").." removed a counter-terrorist bot.")
			return vsa.suc_color.."A counter-terrorist bot was removed."
		end,
		function(id2)
			tmp2=0
			tmp3=0
			for _,id in ipairs(player(0,"table")) do
				if player(id,"bot") then
					if player(id,"team")==1 then
						tmp2=tmp2+1
					elseif player(id,"team")==2 then
						tmp3=tmp3+1
					end
				end
			end
			if tmp2==0 and tmp3==0 then
				return vsa.err_color.."There are no bots to remove"
			end
			local tmp5=#player(0,"team1")
			parse("bot_remove")
			if #player(0,"team1")<tmp5 then
				msg(string.char(169)..vsa.rsp_color..player(id2,"name").." removed a terrorist bot.")
				return vsa.suc_color.."A terrorist bot was removed."
			else
				msg(string.char(169)..vsa.rsp_color..player(id2,"name").." removed a counter-terrorist bot.")
				return vsa.suc_color.."A counter-terrorist bot was removed."
			end
		end,
		function(id2)
			parse("bot_remove_all")
			msg(string.char(169)..vsa.rsp_color..player(id2,"name").." removed all bots.")
			return vsa.suc_color.."All bots were removed."
		end}
	return {tmp,tmp4}
end

menus["Death Slap"]=function()
local tmp={}
local tmp2={}
local tmp3=""
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			if player(id,"team")==1 then
				tmp3="|T"
			else
				tmp3="|CT"
			end
			table.insert(tmp,player(id,"name")..tmp3)
		else
			if player(id,"team")==0 then
				tmp3=""
			elseif player(id,"team")==1 then
				tmp3="/T"
			elseif player(id,"team")==2 then
				tmp3="/CT"
			end
			table.insert(tmp,"("..player(id,"name")..")|DEAD"..tmp3)
		end
		table.insert(tmp2,function(id2,text,ip,name) 
			if player(id,"exists") and player(id,"ip")==ip then
				if player(id,"health")>0 then
					parse("deathslap "..player(id,"name"))
					if id==id2 then
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." death slapped their self.")
					else
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." death slapped "..player(id,"name")..".")
					end
					return vsa.suc_color..player(id2,"name").." was deathslapped."
				else
					return vsa.wrn_color..player(id2,"name").." has died before you could death slap them."
				end
			else
				return vsa.err_color..name.." has quit the game before you could death slap them."
			end
		end)
		table.insert(tmp4,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Flash Player"]=function()
local tmp={}
local tmp2={}
local tmp3=""
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			if player(id,"team")==1 then
				tmp3="|T"
			else
				tmp3="|CT"
			end
			table.insert(tmp,player(id,"name")..tmp3)
		else
			if player(id,"team")==0 then
				tmp3=""
			elseif player(id,"team")==1 then
				tmp3="/T"
			elseif player(id,"team")==2 then
				tmp3="/CT"
			end
			table.insert(tmp,"("..player(id,"name")..")|DEAD"..tmp3)
		end
		table.insert(tmp2,function(id2,text,ip,name) 
			if player(id,"exists") and player(id,"ip")==ip then
				if player(id,"health")>0 then
					parse("flashplayer "..id.." 100")
					if id==id2 then
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." flashed their self.")
					else
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." flashed "..player(id,"name")..".")
					end
					return vsa.suc_color..player(id,"name").." was flashed."
				else
					return vsa.wrn_color..player(id2,"name").." has died before you could flash them."
				end
			else
				return vsa.err_color..name.." has quit the game before you could flash them."
			end
		end)
		table.insert(tmp4,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Kick Player"]=function(id2)
local tmp={}
local tmp2={}
local tmp3={}
	for _,id in ipairs(player(0,"table")) do
		if id==id2 then
			table.insert(tmp,"("..player(id,"name")..")|YOURSELF")
		elseif player(id,"bot") then
			table.insert(tmp,player(id,"name").."|BOT")
		elseif player(id,"ip")=="0.0.0.0" then
			table.insert(tmp,"("..player(id,"name")..")|HOST")
		else
			table.insert(tmp,player(id,"name"))
		end
		table.insert(tmp2,function(id2,text,ip,name) 
			if player(id,"exists") and player(id,"ip")==ip then
				parse("kick "..player(id,"name"))
				if id==id2 then
					return vsa.err_color.."You may not kick yourself."
				elseif player(id,"ip")=="0.0.0.0" and player(id,"bot")==false then
					return vsa.err_color.."You may not kick the host."
				else
					msg(string.char(169)..vsa.rsp_color..player(id2,"name").." kicked "..player(id,"name")..".")
					parse("kick "..player(id,"name"))
					return vsa.suc_color..name.." was kicked."
				end
			else
				return vsa.err_color..name.." has quit the game before you could kick them."
			end
		end)
		table.insert(tmp3,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp3}
end

menus["Kill Player"]=function()
local tmp={}
local tmp2={}
local tmp3=""
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			if player(id,"team")==1 then
				tmp3="|T"
			else
				tmp3="|CT"
			end
			table.insert(tmp,player(id,"name")..tmp3)
		else
			if player(id,"team")==0 then
				tmp3=""
			elseif player(id,"team")==1 then
				tmp3="/T"
			elseif player(id,"team")==2 then
				tmp3="/CT"
			end
			table.insert(tmp,"("..player(id,"name")..")|DEAD"..tmp3)
		end
		table.insert(tmp2,function(id2,text,ip,name) 
			if player(id,"exists") and player(id,"ip")==ip then
				if player(id,"health")>0 then
					parse("killplayer "..id)
					if id==id2 then
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." killed their self.")
					else
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." killed "..player(id,"name")..".")
					end
					return vsa.suc_color..player(id,"name").." was killed."
				else
					return vsa.wrn_color..player(id,"name").." has died before you could kill them."
				end
			else
				return vsa.err_color..name.." has quit the game before you could kill them."
			end
		end)
		table.insert(tmp4,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Make Terrorist"]=function(id2)
	tmp={}
	tmp2={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"team")==1 then
			table.insert(tmp,"("..player(id,"name")..")|Already T")
		elseif player(id,"team")==2 then
			table.insert(tmp,player(id,"name").."|CT")
		else
			table.insert(tmp,player(id,"name").."|Spec")
		end
		table.insert(tmp2,function(id3)
			if player(id,"team")==1 then
				return vsa.err_color..player(id,"name").." is already a terrorist."
			else
				tmp3=player(id,"name")
				if id3==id then
					tmp3="theirself"
				end
				msg(string.char(169)..vsa.rsp_color..player(id3,"name").." made "..tmp3.." a terrorist.")
				parse("maket "..id)
				return vsa.suc_color..player(id,"name").." was made a terrorist."
			end
		end)
	end
	return {tmp,tmp2}
end

menus["Make Counter-Terrorist"]=function(id2)
	tmp={}
	tmp2={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"team")==2 then
			table.insert(tmp,"("..player(id,"name")..")|Already CT")
		elseif player(id,"team")==1 then
			table.insert(tmp,player(id,"name").."|T")
		else
			table.insert(tmp,player(id,"name").."|Spec")
		end
		table.insert(tmp2,function(id3)
			if player(id,"team")==2 then
				return vsa.err_color..player(id,"name").." is already a counter-terrorist."
			else
				tmp3=player(id,"name")
				if id3==id then
					tmp3="theirself"
				end
				msg(string.char(169)..vsa.rsp_color..player(id3,"name").." made "..tmp3.." a counter-terrorist.")
				parse("makect "..id)
				return vsa.suc_color..player(id,"name").." was made a counter-terrorist."
			end
		end)
	end
	return {tmp,tmp2}
end

menus["Make Spectator"]=function(id2)
	tmp={}
	tmp2={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"team")==0 then
			table.insert(tmp,"("..player(id,"name")..")|Already Spec")
		elseif player(id,"team")==1 then
			table.insert(tmp,player(id,"name").."|T")
		else
			table.insert(tmp,player(id,"name").."|CT")
		end
		table.insert(tmp2,function(id3)
			if player(id,"team")==0 then
				return vsa.err_color..player(id,"name").." is already a spectator."
			else
				tmp3=player(id,"name")
				if id3==id then
					tmp3="theirself"
				end
				msg(string.char(169)..vsa.rsp_color..player(id3,"name").." made "..tmp3.." a spectator.")
				parse("makespec "..id)
				return vsa.suc_color..player(id,"name").." was made a spectator."
			end
		end)
	end
	return {tmp,tmp2}
end
	
menus["Shake Player"]=function()
local tmp={}
local tmp2={}
local tmp3=""
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			if player(id,"team")==1 then
				tmp3="|T"
			else
				tmp3="|CT"
			end
			table.insert(tmp,player(id,"name")..tmp3)
		else
			if player(id,"team")==0 then
				tmp3=""
			elseif player(id,"team")==1 then
				tmp3="/T"
			elseif player(id,"team")==2 then
				tmp3="/CT"
			end
			table.insert(tmp,"("..player(id,"name")..")|DEAD"..tmp3)
		end
		table.insert(tmp2,function(id2,text,ip,name) 
			if player(id,"exists") and player(id,"ip")==ip then
				if player(id,"health")>0 then
					parse("shake "..id.." 30")
					if id==id2 then
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." shook their self.")
					else
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." shook "..player(id,"name")..".")
					end
					return vsa.suc_color..player(id,"name").." was flashed."
				else
					return vsa.wrn_color..player(id2,"name").." has died before you could shake them."
				end
			else
				return vsa.err_color..name.." has quit the game before you could shake them."
			end
		end)
		table.insert(tmp4,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Slap Player"]=function()
local tmp={}
local tmp2={}
local tmp3=""
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			if player(id,"team")==1 then
				tmp3="|T"
			else
				tmp3="|CT"
			end
			table.insert(tmp,player(id,"name")..tmp3)
		else
			if player(id,"team")==0 then
				tmp3=""
			elseif player(id,"team")==1 then
				tmp3="/T"
			elseif player(id,"team")==2 then
				tmp3="/CT"
			end
			table.insert(tmp,"("..player(id,"name")..")|DEAD"..tmp3)
		end
		table.insert(tmp2,function(id2,text,ip,name) 
			if player(id,"exists") and player(id,"ip")==ip then
				if player(id,"health")>0 then
					parse("slap "..player(id,"name"))
					if id==id2 then
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." slapped their self.")
					else
						msg(string.char(169)..vsa.rsp_color..player(id2,"name").." slapped "..player(id,"name")..".")
					end
				else
					return vsa.wrn_color..player(id2,"name").." has died before you could slap them."
				end
			else
				return vsa.err_color..name.." has quit the game before you could slap them."
			end
		end)
		table.insert(tmp4,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Strip Player"]=function()
local tmp={}
local tmp2={}
local tmp3=""
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			if #playerweapons(id)==1 then
				table.insert(tmp,"("..player(id,"name")..")|No Weapons")
			else
				table.insert(tmp,player(id,"name").."|"..#playerweapons(id))
			end
		else
			table.insert(tmp,"("..player(id,"name")..")|DEAD")
		end
		table.insert(tmp2,function(id2,text,ip,name) 
			if player(id,"exists") and player(id,"ip")==ip then
				if player(id,"health")>0 then
					tmp5=#playerweapons(id)
					if tmp5==1 then
						return vsa.err_color..player(id,"name").." has no weapons to strip."
					end
					for _2,id3 in ipairs(playerweapons(id)) do
						parse("strip "..id.." "..id3)
					end
					if id==id2 then
						msg(string.char(169)..vsa.rsp_color..player(id,"name").." stripped their self.")
					else
						msg(string.char(169)..vsa.rsp_color..player(id,"name").." stripped "..player(id,"name")..".")
					end
					tmp6="s"
					if tmp5-#playerweapons(id)==1 then
						tmp6=""
					end
					msg2(id2,string.char(169)..vsa.rsp_color..player(id,"name").." was stripped of "..tmp5-#playerweapons(id).." weapon"..tmp6..".")
					return vsa.suc_color..player(id,"name").." was stripped."
				else
					return vsa.wrn_color..player(id,"name").." has died before you could strip them."
				end
			else
				return vsa.err_color..name.." has quit the game before you could strip them."
			end
		end)
		table.insert(tmp4,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Spawn Player"]=function()
local tmp={}
local tmp2={}
local tmp4={}
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			table.insert(tmp,"("..player(id,"name")..")|Alive")
		elseif player(id,"team")==0 then
			table.insert(tmp,"("..player(id,"name")..")|Spectator")
		else
			if player(id,"team")==1 then
				table.insert(tmp,player(id,"name").."|Terrorist")
			else
				table.insert(tmp,player(id,"name").."|Counter-Terrorist")
			end
		end
		table.insert(tmp2,function(id2,text,name,ip)
			if player(id,"exists")==false or player(id,"ip")~=ip then
				return vsa.wrn_color..name.." has left the game before you could spawn them."
			elseif player(id,"health")>0 then
				return vsa.wrn_color..player(id,"name").." is not dead. Only dead players can be spawned."
			elseif player(id,"team")==0 then
				return vsa.err_color..player(id,"name").." has not joined a team. Only players on a team can be spawned."
			else
				tmp6=player(id,"name")
				if id2==id then
					tmp6="theirself"
				end
				msg(string.char(169)..vsa.rsp_color..player(id2,"name").." spawned "..tmp6..".")
				tmp3,tmp5=randomentity(tostring(player(id,"team")-1))
				parse("spawnplayer "..id.." "..(tmp3*32).." "..(tmp5*32))
				return vsa.suc_color..player(id,"name").." was spawned at tile[x]: "..tmp3..", tile[y]: "..tmp5.."."
			end
		end)
		table.insert(tmp4,{player(id,"name"),player(id,"ip")})
	end
	return {tmp,tmp2,tmp4}
end

menus["Reset Score"]=function(id2)
	local tmp={}
	if player(id2,"deaths")<=0 then
		msg2(id2,string.char(169)..vsa.con_color.."You do not have enough deaths to reset your score.@C")
		tmp3="(Reset Score)|0 Deaths"
	else
		msg2(id2,string.char(169)..vsa.con_color.."Are you sure you want to reset your score?@C")
		tmp3="Reset Score"
	end
	tmp={tmp3,"No|Exit"}
	tmp2={function(id3)
			if player(id3,"deaths")>=1 then
				msg(string.char(169)..vsa.rsp_color..player(id3,"name").." resetted their score.")
				parse("setscore "..id3.." 0")
				parse("setdeaths "..id3.." 0")
				return vsa.suc_color.."Your score was reset."
			else
				return vsa.wrn_color.."You do not have enough deaths to reset your score."
			end
		end,
		function()
		end}
	return {tmp,tmp2}
end

--gather maps for Change Map menu
vsa.maps={}
if os.getenv("HOME")==nil then --on linux
	os.execute("dir maps\ > tmpmap")
	for file1 in io.lines("tmpmap") do
        	if file1:sub(-4) == ".map" then
                	table.insert(vsa.maps,string.sub(file1, 40, -5))
        	end
	end
else --windows
	os.execute("dir maps/ -1 > tmpmap")
	for file1 in io.lines("tmpmap") do
        	if file1:sub(-4) == ".map" then
			tmp=string.sub(file1, 0, -5)
			while string.find(tmp,"\\")~=nil do
				tmp=string.gsub(string.sub(file1, 0, -5),"\\","")
			end
                	table.insert(vsa.maps,tmp)
        	end
	end
end

menus["Change Map"]=function()
	local tmp={}
	local tmp3={}
	for _,map in ipairs(vsa.maps) do
		table.insert(tmp," "..map.." |.map")
		table.insert(tmp3,map)
	end
	local tmp2={}
	for key,map in ipairs(tmp) do
		table.insert(tmp2,function(id2,text)
				msg2(id2,string.char(169)..vsa.con_color.."Are you sure you want to change the map to '"..tmp3[key].."'?@C")
				tmp4={"Yes|Load '"..tmp3[key].."'","No|Exit"}
				tmp5={function(id3)
					msg(string.char(169)..vsa.rsp_color..player(id3,"name").." changed the map to '"..tmp3[key].."'.")
					timer(2000,"parse","map "..tmp3[key])
					return vsa.suc_color.."The map was changed to '"..tmp3[key].."'."
				end,
				function()
				end}
				return {tmp4,tmp5}
			end)
	end
	return {tmp,tmp2}
end

menus["Set Armor"]=function()
	local tmp={}
	local tmp2={}
	local tmp6={}
	local tmp3={"No Armor","Kevlar+Helm","Armor","Heavy Armor","Medic Armor","Super Armor","Stealth Suit"}
	local tmp4={0,100,202,203,204,205,206}
	local findName=function(num)
		for index,name in pairs(tmp4) do
			if num==name then
				return tmp3[index]
			end
		end
		return num
	end
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			table.insert(tmp,player(id,"name").."|"..findName(player(id,"armor")))
		else
			table.insert(tmp,"("..player(id,"name")..")|DEAD")
		end
		table.insert(tmp2,function(id2,text,ip,name)
			tmp5={}
			for key,item in ipairs(tmp3) do
				table.insert(tmp5,function(id2,text,ip2,name2)
					if player(id,"exists")==false or ip2==player(id,"ip") then
						return vsa.err_color.." has left the game before you could set their armor."
					else
						if player(id,"health")>=0 then
							tmp7=player(id,"name").."'s"
							if id2==id then
								tmp7="their own"
							end
							msg(string.char(169)..vsa.rsp_color..player(id2,"name").." set "..tmp7.." armor to '"..item.."'.")
							parse("setarmor "..id.." "..tmp4[key])
							return vsa.suc_color..player(id,"name").."'s armor was set to '"..item.."'."
						else
							return vsa.wrn_color..player(id,"name").." has died before you could set their armor."
						end
					end
				end)
			end
			return {tmp3,tmp5}
		end)
		table.insert(tmp6,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp6}
end

menus["Set Health"]=function()
	local tmp={}
	local tmp2={}
	local tmp6={}
	local tmp3={"1 HP","20 HP","30 HP","40 HP","50 HP","69 HP","100 HP"}
	local tmp4={1,20,30,40,50,69,100}
	local findName=function(num)
		for index,name in pairs(tmp4) do
			if num==name then
				return tmp3[index]
			end
		end
		return num
	end
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			table.insert(tmp,player(id,"name").."|"..findName(player(id,"health")))
		else
			table.insert(tmp,"("..player(id,"name")..")|DEAD")
		end
		table.insert(tmp2,function(id2,text,ip,name)
			tmp5={}
			for key,item in ipairs(tmp3) do
				table.insert(tmp5,function(id2,text,ip2,name2)
					if player(id,"exists")==false or ip2==player(id,"ip") then
						return vsa.err_color.." has left the game before you could set their health."
					else
						if player(id,"health")>=0 then
							tmp7=player(id,"name").."'s"
							if id2==id then
								tmp7="their own"
							end
							msg(string.char(169)..vsa.rsp_color..player(id2,"name").." set "..tmp7.." health to '"..item.."'.")
							parse("sethealth "..id.." "..tmp4[key])
							return vsa.suc_color..player(id,"name").."'s health was set to '"..item.."'."
						else
							return vsa.wrn_color..player(id,"name").." has died before you could set their health."
						end
					end
				end)
			end
			return {tmp3,tmp5}
		end)
		table.insert(tmp6,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp6}
end
menus["Set Speedmod"]=function()
	local tmp={}
	local tmp2={}
	local tmp6={}
	local tmp3={"Immobile","Very Slow","Slow","Regular","Fast","Very Fast","Speed Hacker"}
	local tmp4={-50,-10,-5,0,5,10,100}
	local findName=function(num)
		for index,name in pairs(tmp4) do
			if num==name then
				return tmp3[index]
			end
		end
		return num
	end
	for _,id in ipairs(player(0,"table")) do
		if player(id,"health")>0 then
			table.insert(tmp,player(id,"name").."|"..findName(player(id,"speedmod")))
		else
			table.insert(tmp,"("..player(id,"name")..")|DEAD")
		end
		table.insert(tmp2,function(id2,text,ip,name)
			tmp5={}
			for key,item in ipairs(tmp3) do
				table.insert(tmp5,function(id2,text,ip2,name2)
					if player(id,"exists")==false or ip2==player(id,"ip") then
						return vsa.err_color.." has left the game before you could set their speed."
					else
						if player(id,"health")>=0 then
							tmp7=player(id,"name").."'s"
							if id2==id then
								tmp7="their own"
							end
							msg(string.char(169)..vsa.rsp_color..player(id2,"name").." set "..tmp7.." speed to '"..item.."'.")
							parse("speedmod "..id.." "..tmp4[key])
							return vsa.suc_color..player(id,"name").."'s speed was set to '"..item.."'."
						else
							return vsa.wrn_color..player(id,"name").." has died before you could set their speed."
						end
					end
				end)
			end
			return {tmp3,tmp5}
		end)
		table.insert(tmp6,{player(id,"ip"),player(id,"name")})
	end
	return {tmp,tmp2,tmp6}
end

menus["List Users"]=function()
local tmp={}
local tmp2={}
	for _,id in ipairs(player(0,"table")) do
		if vsa.users[player(id,"usgn")]~=nil then
			if vsa.users[player(id,"usgn")]~=nil then
				table.insert(tmp,"("..player(id,"name")..")|"..vsa.users[player(id,"usgn")])
				table.insert(tmp2,function()
						end)
			end
		end
	end
	return {tmp,tmp2}
end

menus["Set F3"]=function(id)
	local tmp={}
	for _,item in ipairs(menus[vsa.menu_default[id][1]]) do
		if menus[item]~=nil then
			table.insert(tmp,item)
		end
	end
	local tmp2={}
	for _,item in ipairs(menus[vsa.menu_default[id][1]]) do
		table.insert(tmp2,function(id,text)
					vsa.menu_default[id][2]=text
					return vsa.suc_color.."Your F3 now redirects to '"..text.."'."
				end
			)
	end
	return {tmp,tmp2}
end

menus["Set F4"]=function(id)
	local tmp={}
	for _,item in ipairs(menus[vsa.menu_default[id][1]]) do
		if menus[item]~=nil then
			table.insert(tmp,item)
		end
	end
	local tmp2={}
	for _,item in ipairs(menus[vsa.menu_default[id][1]]) do
		table.insert(tmp2,function(id,text)
					vsa.menu_default[id][3]=text
					return vsa.suc_color.."Your F4 now redirects to '"..text.."'."
				end
			)
	end
	return {tmp,tmp2}
end

menus["Unset F3"]=function(id)
	tmp3="Reset F3"
	if vsa.menu_default[id][2]=="Set F3" then
		tmp3="(Reset F3)|Already Unset"
	end
	local tmp={tmp3,"Keep F3"}
	local tmp2={function(id)
				if vsa.menu_default[id][2]=="Set F3" then
					return vsa.err_color.."Your F3 was already unset, please set it first."
				else
					vsa.menu_default[id][2]="Set F3"
					return vsa.suc_color.."Your F3 was unset, press F3 to set another redirection."
				end
			end
			,
			function()
			end}
	return {tmp,tmp2}
end

menus["Unset F4"]=function(id)
	tmp3="Reset F4"
	if vsa.menu_default[id][3]=="Set F4" then
		tmp3="(Reset F4)|Already Unset"
	end
	local tmp={tmp3,"Keep F4"}
	local tmp2={function(id)
				if vsa.menu_default[id][2]=="Set F4" then
					return vsa.err_color.."Your F4 was already unset, please set it first."
				else
					vsa.menu_default[id][2]="Set F4"
					return vsa.suc_color.."Your F4 was unset, press F4 to set another redirection."
				end
			end
			,
			function()
			end}
	return {tmp,tmp2}
end

menus["Restart Round"]=function(id)
	msg2(id,string.char(169)..vsa.con_color.."Are you sure you want to restart this round?@C")
	tmp={"Yes|Restart","No|Exit"}
	tmp2={function(id2)
			msg(string.char(169)..vsa.rsp_color..player(id2,"name").." restarted the round.")
			parse("restart")
			return vsa.suc_color.."The round was restarted."
		end,
		function()
		end}
	return {tmp,tmp2}
end

menus["Time"]=function(id)
	return vsa.rsp_color.."The time on the server is "..os.date("%I:%M %p").."."
end
menus["Date"]=function(id)
	return vsa.rsp_color.."The date on the server is "..os.date("%A, %d %b %Y").."."
end
menus["Next Map"]=function(id)
	return vsa.rsp_color.."The next map is: "..game("nextmap").."."
end
--Menus
vsa.ranks={"User","VIP","Moderator","Administrator"} --all ranks point to a menu, user = no login, you can add more ranks :)
menus["User"]={"Reset Score","Time","Date","Next Map","Unset F3","Unset F4"}
menus["VIP"]={"Reset Score","Slap Player","Strip Player","Spawn Player","Make Terrorist","Make Counter-Terrorist","Make Spectator","Kill Player","Time","Date","Next Map","Unset F3","Unset F4"}
menus["Moderator"]={"Restart Round","Punish Players","Reset Score","List Users","Set Armor","Set Health","Set Speedmod","Time","Date","Next Map","Unset F3","Unset F4"}
menus["Punish Players"]={"Slap Player","Strip Player","Spawn Player","Kick Player","Shake Player","Death Slap","Flash Player","Kill Player"}
menus["Administrator"]={"Server Settings","Manage Players","Bots","Restart Round","Change Map","List Users","Time","Date","Next Map","Unset F3","Unset F4"}
menus["Manage Players"]={"Ban IP","Ban USGN","Ban Name","Slap Player","Set Armor","Set Health","Set Speedmod","Strip Player","Spawn Player","Make Terrorist","Make Counter-Terrorist","Make Spectator","Shake Player","Death Slap","Flash Player","Kill Player"}
menus["Bots"]={"Add Bot","Remove A Bot","Kill All Bots"}