--Hooks
addhook("join","vsa._join")
addhook("leave","vsa._leave")
addhook("name","vsa._name")
--functions
function vsa._join(id)
	--this is critical, allowing '|' or '(' or ')' will result in malformed menus and making it impossible to punish players
	local tmp=player(id,"name")
	while tmp:find("%|")~=nil do
		tmp=string.gsub(tmp, "%|", "")
	end
	while tmp:find("%(")~=nil do
		tmp=string.gsub(tmp, "%(", "")
	end
	while tmp:find("%)")~=nil do
		tmp=string.gsub(tmp, "%)", "")
	end
	if tmp~=player(id,"name") then
		parse("setname "..id.." "..tmp)
	end
	local level=vsa.users[player(id,"usgn")] or vsa.users[0]
	vsa.menu_default[id]={level,"Set F3","Set F4"}
	msg2(id,string.char(169)..vsa.suc_color.."Welcome to "..game("sv_name").." "..player(id,"name")..", your power level is "..level..".")
end
function vsa._leave(id)
	vsa.player_pos[id]=nil --reset the postion of the menu
	vsa.act[id]=nil --unset actions
end
function vsa._name(id,oldname,newname)
	--[[
		this is critical, allowing '|' or '(' or ')' will result in malformed menus and making it impossible to punish players
		good thing cs2d doesn't allow commas in names, so we don't need to strip it
	--]]
	local tmp=newname
	while tmp:find("%|")~=nil do
		tmp=string.gsub(tmp, "%|", "")
	end
	while tmp:find("%(")~=nil do
		tmp=string.gsub(tmp, "%(", "")
	end
	while tmp:find("%)")~=nil do
		tmp=string.gsub(tmp, "%)", "")
	end
	if tmp~=newname then
		parse("setname "..id.." "..tmp)
		return 1
	end
end